local const = {
    _version = "0.1.0",

    linkedge = {
        bus_addr = "unix:path=/tmp/var/run/mbusd/mbusd_socket"
    },

    default_user = {
        name = "admin",
        password = "admin1234"
    },

    subscribe = {
        wkn = "iot.dmp.subscribe",
        obj = "/iot/dmp/subscribe",
        inf = "iot.dmp.subscribe",
        interface_sub = "subscribeDeviceEvent",
        interface_unsub = "unsubscribeDeviceEvent",
        interface_read_list = "readRuleTableConfig",
        fmt_sub_raw = "{\"version\": \"1.0\",\"content\":[{\"source\": {\"type\": \"%s\",\"data\": \"%s\"},\"topicFilter\":\"%s\",\"target\":{\"type\":\"%s\"}}]}",
        -- fmt_sub = "{\"subscriber\":\"%s\", \"content\": [{\"deviceModuleName\": \"%s\", \"rule\": {}}]}"
        fmt_sub = "{\"version\": \"1.0\",\"content\":[{\"source\": {\"type\": \"device\",\"data\": \"/%s/%s\"}, \
        \"topicFilter\":\"all\",\"target\":{\"type\":\"%s\"}}]}"
    },

    dimu = {
        wkn = "iot.dmp.dimu",
        obj = "/iot/dmp/dimu",
        inf = "iot.dmp.dimu",
        method = {
            unregisterDriver = "unregisterDriver",
            fmt_unregisterDriver = "{\"params\": {\"driverLocalId\": \"%s\"}}",
            registerDevice = "registerDevice",
            fmt_registerDevice = "{\"productKey\": \"%s\", \"deviceName\": \"%s\", \"driverName\": \"%s\"}"
        }
    },

    scene = {
        wkn = "iot.gateway.scene",
        obj = "/iot/gateway/scene",
        inf = "iot.gateway.scene",
        method = {
            enable_scene = "enableScene",
            disable_scene = "disableScene",
            invoke_scene = "invokeScene",
            list_scene_stats = "listSceneStats",
        }
    },

    cmp = {
        wkn_prefix = "iot.device.id",
        obj_prefix = "/iot/device/id",
        inf_prefix = "iot.device.id"
    },

    stream_compute = {
        wkn = "iot.edge.StreamCompute",
        obj = "/iot/edge/StreamCompute",
        inf = "iot.edge.StreamCompute",

        method = {
            getJobList = "getJobList",
            removeJob = "deleteJob",
            getJobDetail = "getJobDetail",
            stopJob = "stopJob",
            startJob = "startJob",
            saveJobCode = "saveJobContent",
            newJob = "newJob"
        }
    },

    function_compute = {
        wkn = "iot.gateway.fcbase",
        obj = "/iot/gateway/fcbase",
        inf = "iot.gateway.fcbase",

        method = {
            invoke_function = "invokeFunction",
            deploy_function = "deployFunction",
            restart_functions = "restartFunctions",
            reset = "reset"
        }
    },
    device_ota = {
        wkn = "iot.gateway.deviceota",
        obj = "/iot/gateway/deviceota",
        inf = "iot.gateway.deviceota",
        method = {
            list_drivers = "queryDriver",
            list_devices = "queryDevice",
            list_histories = "queryHistory",
            start_upgrade = "startOta",
        }
    },

    kapacitor = {
        base_url = "http://127.0.0.1:9092/kapacitor"
    },

    data_key = {
        eweb = {
            user = "gw_eweb_user",
            product_key_list = "gw_eweb_productkeylist"
        },

        tsl = {
            standard_tsl_prefix = "gw_TSL_",
            extend_tsl_prefix = "gw_TSL_config_",
        },

        gwconfig = {
            -- gateway product key, device name and device secret
            productkey = "gw_system_productkey",
            devicename = "gw_system_devicename",
            devicesecret = "gw_system_devicesecret"
        },

        logger = {
            dir = "gw_logger_dir", -- logger directory
            max_size = "gw_logger_totalsize", -- logger total size in MB
            level = "gw_logger_level"               -- logger level
        },

        driver = {
            --[[ {
                    "DriverConfig": string,
                    "DeviceConfig": [
                        $JSON_STRING,
                        $JSON_STRING,
                        $JSON_STRING 
                    ]
                }
            ]]--

            --[[
            Device_Config_JSON_STRING
            {
                "ProductKey": string, 
                "DeviceName": string,
                "Config": $JSON_STRING,
            }
            ]]--

            -- driver_config = $prefix + $drivername, e.g. gw_driver_modbus
            prefix = "gw_driverconfig_",

        },

        dimu = {
            -- static device 3tuple,
            -- value: string of nested json array, e.g. [["pk1", "dn1", "ds1"], ["pk2", "dn2", "ds2"], ["pk3", "dn3", "ds3"]]
            device_3tuple = "gw_dimu_devicetuple",
            device_3tuple_quanlity = "gw_dimu_3tuplequanlity",


            -- enable device auto authorize
            -- value: single string, one of ["on", "off"]
            auto_auth_sw = "gw_dimu_autoauth",

            -- switch of dimu dynamic register
            -- value: single string, one of ["on", "off"]
            dynamic_reg_sw = "gw_dimu_dyreg"
        },
        system = {
            users = "gw_webconsole_users"
        },
    },
    tsl = {
        prefix = "gw_TSL_",
        extend_prefix = "gw_TSL_config_",
    },
    -- 400
    BAD_REQUEST = "BadRequest",
    INVALID_PARAMETER = "InvalidParameter",
    MISSING_PARAMETER = "MissingParameter",
    -- 401
    UNAUTHORIZED = "Unauthorized",
    -- 403
    FORBIDDEN = "Forbidden",
    -- 404
    NOT_FOUND = "NotFound",
    -- 405
    METHOD_NOT_ALLOWED = "MethodNotAllowed",
    -- 500
    INTERNAL_SERVER_ERROR = "InternalServerError",
    COOKIE_HANDLER_CREATE = "Cookie.Handler.Create",
    COOKIE_SET = "Cookie.Set",
    HMAC = "HMAC",
    CONNECTION_CREATE = "Connection.Create",
    CONNECTION_LOST = "Connection.Lost",
    MESSAGE_CREATE = "Message.Create",
    MESSAGE_SENDANDREPLY = "Message.SendAndReply",
    MESSAGE_INVALIDREPLY = "Message.InvalidReply",
    MESSAGE_FAILEDREPLY = "Message.FailedReply",
    SERVICE_NOT_EXIST = "Service.NotExist",
    SERVICE_DATA_KEY_NOT_EXIST = "Service.Data.KeyNotExist",
    SERVICE_DATA_GET = "Service.Data.Get",
    SERVICE_DATA_SET = "Service.Data.Set",
    SERVICE_THING_CALL = "Service.Thing.Call",
    SERVICE_FUNCTION_NOT_EXIST = "Service.Function.NotExist",
    SERVICE_FUNCTION_TIMEOUT = "Service.Function.Timeout",
    SERVICE_SCENE_NOT_EXIST = "Service.Scene.NotExist",
    SERVICE_SCENE_NOT_AT_LEVEL0 = "Service.Scene.NotAtLevel0",
    -- 503
    SERVICE_UNAVAILABLE = "ServiceUnavailable",
}

return const
