local json = require("json")
local utils = require("utils")
local const = require("const")
local ck = require("resty.cookie")

local request_method = ngx.var.request_method

if "POST" ~= request_method then
    utils.error_exit(400, "unsupported request method")
end

ngx.req.read_body()
local args_json = ngx.req.get_body_data()
local args = json.decode(args_json)
local user = args["User"]

utils.check_username(user)
--local ok, msg = utils.get_data(const.data_key.eweb.user)
--if (ok) then
--    if (msg) then
--        local user_list = json.decode(msg)
--        if (not user_list["UserList"][user]) then
--            utils.error_exit(400, "invalid username")
--        end
--    else
--        utils.error_exit(400, "invalid username")
--    end
--else 
--    utils.error_exit(500, "get user info failed")
--end
--
local cookie, err = ck:new()
if not cookie then
    utils.error_exit(401, err)
end

-- get login cookie
local login_token, err = cookie:get("loginToken")
if login_token then
    -- delete login cookie if existing
    local memkv = ngx.shared.memkv
    val = memkv:get(login_token)
    local user_mem = memkv:get(login_token .. "." .. "username")
    if (nil ~= val) and (user_mem == user) then
        memkv:delete(login_token)
        memkv:delete(login_token .. "." .. "username")
        utils.error_exit(200)
    end
end


utils.error_exit(401, "user is not logined.")

------ EOF ------
